import { DocAgnosticFormat, ObjectMap } from '@0x/types';
export declare class SolDoc {
    private _customTypeHashToName;
    private static _genEventDoc;
    private static _devdocMethodDetailsIfExist;
    private static _genFallbackDoc;
    private static _genEventArgsDoc;
    private static _dedupStructs;
    private static _capitalize;
    private static _generateCustomTypeHash;
    private static _makeCompilerOptions;
    /**
     * Invoke the Solidity compiler and transform its ABI and devdoc outputs into a
     * JSON format easily consumed by documentation rendering tools.
     * @param contractsToDocument list of contracts for which to generate doc objects
     * @param contractsDir the directory in which to find the `contractsToCompile` as well as their dependencies.
     * @return doc object for use with documentation generation tools.
     */
    generateSolDocAsync(contractsDir: string, contractsToDocument?: string[], customTypeHashToName?: ObjectMap<string>): Promise<DocAgnosticFormat>;
    private _getCustomTypeFromDataItem;
    private _getNameFromDataItemIfExists;
    private _getTypeFromDataItem;
    private _overwriteStructNames;
    private _extractStructs;
    private _genDocSection;
    private _genConstructorDoc;
    private _genMethodDoc;
    /**
     * Extract documentation for each method parameter from @param params.
     */
    private _genMethodParamsDoc;
    private _genMethodReturnTypeDoc;
    private _getStructsAsCustomTypes;
}
//# sourceMappingURL=sol_doc.d.ts.map