"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var ethUtil = require("ethereumjs-util");
var _ = require("lodash");
var sol_compiler_1 = require("@dexon-foundation/sol-compiler");
var types_1 = require("@0x/types");
var SolDoc = /** @class */ (function () {
    function SolDoc() {
    }
    SolDoc._genEventDoc = function (abiDefinition) {
        var eventDoc = {
            name: abiDefinition.name,
            eventArgs: SolDoc._genEventArgsDoc(abiDefinition.inputs),
        };
        return eventDoc;
    };
    SolDoc._devdocMethodDetailsIfExist = function (methodSignature, devdocIfExists) {
        var details;
        if (!_.isUndefined(devdocIfExists)) {
            var devdocMethodsIfExist = devdocIfExists.methods;
            if (!_.isUndefined(devdocMethodsIfExist)) {
                var devdocMethodIfExists = devdocMethodsIfExist[methodSignature];
                if (!_.isUndefined(devdocMethodIfExists)) {
                    var devdocMethodDetailsIfExist = devdocMethodIfExists.details;
                    if (!_.isUndefined(devdocMethodDetailsIfExist)) {
                        details = devdocMethodDetailsIfExist;
                    }
                }
            }
        }
        return details;
    };
    SolDoc._genFallbackDoc = function (abiDefinition, devdocIfExists) {
        var methodSignature = "()";
        var comment = SolDoc._devdocMethodDetailsIfExist(methodSignature, devdocIfExists);
        var returnComment = _.isUndefined(devdocIfExists) || _.isUndefined(devdocIfExists.methods[methodSignature])
            ? undefined
            : devdocIfExists.methods[methodSignature].return;
        var methodDoc = {
            isConstructor: false,
            name: 'fallback',
            callPath: '',
            parameters: [],
            returnType: { name: 'void', typeDocType: types_1.TypeDocTypes.Intrinsic },
            returnComment: returnComment,
            isConstant: true,
            isPayable: abiDefinition.payable,
            isFallback: true,
            comment: _.isEmpty(comment)
                ? 'The fallback function. It is executed on a call to the contract if none of the other functions match the given public identifier (or if no data was supplied at all).'
                : comment,
        };
        return methodDoc;
    };
    SolDoc._genEventArgsDoc = function (args) {
        var e_1, _a;
        var eventArgsDoc = [];
        try {
            for (var args_1 = __values(args), args_1_1 = args_1.next(); !args_1_1.done; args_1_1 = args_1.next()) {
                var arg = args_1_1.value;
                var name_1 = arg.name;
                var type = {
                    name: arg.type,
                    typeDocType: types_1.TypeDocTypes.Intrinsic,
                };
                var eventArgDoc = {
                    isIndexed: arg.indexed,
                    name: name_1,
                    type: type,
                };
                eventArgsDoc.push(eventArgDoc);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (args_1_1 && !args_1_1.done && (_a = args_1.return)) _a.call(args_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return eventArgsDoc;
    };
    SolDoc._dedupStructs = function (customTypes) {
        var uniqueCustomTypes = [];
        var seenTypes = {};
        _.each(customTypes, function (customType) {
            var hash = SolDoc._generateCustomTypeHash(customType);
            if (!seenTypes[hash]) {
                uniqueCustomTypes.push(customType);
                seenTypes[hash] = true;
            }
        });
        return uniqueCustomTypes;
    };
    SolDoc._capitalize = function (text) {
        return "" + text.charAt(0).toUpperCase() + text.slice(1);
    };
    SolDoc._generateCustomTypeHash = function (customType) {
        var customTypeWithoutName = _.cloneDeep(customType);
        delete customTypeWithoutName.name;
        var customTypeWithoutNameStr = JSON.stringify(customTypeWithoutName);
        var hash = ethUtil.sha256(customTypeWithoutNameStr).toString('hex');
        return hash;
    };
    SolDoc._makeCompilerOptions = function (contractsDir, contractsToCompile) {
        var _a, _b;
        var compilerOptions = {
            contractsDir: contractsDir,
            contracts: '*',
            compilerSettings: {
                outputSelection: (_a = {},
                    _a['*'] = (_b = {},
                        _b['*'] = ['abi', 'devdoc'],
                        _b),
                    _a),
            },
        };
        var shouldOverrideCatchAllContractsConfig = !_.isUndefined(contractsToCompile) && contractsToCompile.length > 0;
        if (shouldOverrideCatchAllContractsConfig) {
            compilerOptions.contracts = contractsToCompile;
        }
        return compilerOptions;
    };
    /**
     * Invoke the Solidity compiler and transform its ABI and devdoc outputs into a
     * JSON format easily consumed by documentation rendering tools.
     * @param contractsToDocument list of contracts for which to generate doc objects
     * @param contractsDir the directory in which to find the `contractsToCompile` as well as their dependencies.
     * @return doc object for use with documentation generation tools.
     */
    SolDoc.prototype.generateSolDocAsync = function (contractsDir, contractsToDocument, customTypeHashToName) {
        return __awaiter(this, void 0, void 0, function () {
            var e_2, _a, e_3, _b, e_4, _c, e_5, _d, docWithDependencies, compilerOptions, compiler, compilerOutputs, structs, compilerOutputs_1, compilerOutputs_1_1, compilerOutput, contractFileNames, contractFileNames_1, contractFileNames_1_1, contractFileName, contractNameToOutput, contractNames, contractNames_1, contractNames_1_1, contractName, compiledContract, doc, contractsToDocument_1, contractsToDocument_1_1, contractToDocument, contractBasename, contractName;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        this._customTypeHashToName = customTypeHashToName;
                        docWithDependencies = {};
                        compilerOptions = SolDoc._makeCompilerOptions(contractsDir, contractsToDocument);
                        compiler = new sol_compiler_1.Compiler(compilerOptions);
                        return [4 /*yield*/, compiler.getCompilerOutputsAsync()];
                    case 1:
                        compilerOutputs = _e.sent();
                        structs = [];
                        try {
                            for (compilerOutputs_1 = __values(compilerOutputs), compilerOutputs_1_1 = compilerOutputs_1.next(); !compilerOutputs_1_1.done; compilerOutputs_1_1 = compilerOutputs_1.next()) {
                                compilerOutput = compilerOutputs_1_1.value;
                                contractFileNames = _.keys(compilerOutput.contracts);
                                try {
                                    for (contractFileNames_1 = __values(contractFileNames), contractFileNames_1_1 = contractFileNames_1.next(); !contractFileNames_1_1.done; contractFileNames_1_1 = contractFileNames_1.next()) {
                                        contractFileName = contractFileNames_1_1.value;
                                        contractNameToOutput = compilerOutput.contracts[contractFileName];
                                        contractNames = _.keys(contractNameToOutput);
                                        try {
                                            for (contractNames_1 = __values(contractNames), contractNames_1_1 = contractNames_1.next(); !contractNames_1_1.done; contractNames_1_1 = contractNames_1.next()) {
                                                contractName = contractNames_1_1.value;
                                                compiledContract = contractNameToOutput[contractName];
                                                if (_.isUndefined(compiledContract.abi)) {
                                                    throw new Error('compiled contract did not contain ABI output');
                                                }
                                                docWithDependencies[contractName] = this._genDocSection(compiledContract, contractName);
                                                structs = __spread(structs, this._extractStructs(compiledContract));
                                            }
                                        }
                                        catch (e_4_1) { e_4 = { error: e_4_1 }; }
                                        finally {
                                            try {
                                                if (contractNames_1_1 && !contractNames_1_1.done && (_c = contractNames_1.return)) _c.call(contractNames_1);
                                            }
                                            finally { if (e_4) throw e_4.error; }
                                        }
                                    }
                                }
                                catch (e_3_1) { e_3 = { error: e_3_1 }; }
                                finally {
                                    try {
                                        if (contractFileNames_1_1 && !contractFileNames_1_1.done && (_b = contractFileNames_1.return)) _b.call(contractFileNames_1);
                                    }
                                    finally { if (e_3) throw e_3.error; }
                                }
                            }
                        }
                        catch (e_2_1) { e_2 = { error: e_2_1 }; }
                        finally {
                            try {
                                if (compilerOutputs_1_1 && !compilerOutputs_1_1.done && (_a = compilerOutputs_1.return)) _a.call(compilerOutputs_1);
                            }
                            finally { if (e_2) throw e_2.error; }
                        }
                        structs = SolDoc._dedupStructs(structs);
                        structs = this._overwriteStructNames(structs);
                        doc = {};
                        if (_.isUndefined(contractsToDocument) || contractsToDocument.length === 0) {
                            doc = docWithDependencies;
                        }
                        else {
                            try {
                                for (contractsToDocument_1 = __values(contractsToDocument), contractsToDocument_1_1 = contractsToDocument_1.next(); !contractsToDocument_1_1.done; contractsToDocument_1_1 = contractsToDocument_1.next()) {
                                    contractToDocument = contractsToDocument_1_1.value;
                                    contractBasename = path.basename(contractToDocument);
                                    contractName = contractBasename.lastIndexOf('.sol') === -1
                                        ? contractBasename
                                        : contractBasename.substring(0, contractBasename.lastIndexOf('.sol'));
                                    doc[contractName] = docWithDependencies[contractName];
                                }
                            }
                            catch (e_5_1) { e_5 = { error: e_5_1 }; }
                            finally {
                                try {
                                    if (contractsToDocument_1_1 && !contractsToDocument_1_1.done && (_d = contractsToDocument_1.return)) _d.call(contractsToDocument_1);
                                }
                                finally { if (e_5) throw e_5.error; }
                            }
                        }
                        if (structs.length > 0) {
                            doc.structs = {
                                comment: '',
                                constructors: [],
                                methods: [],
                                properties: [],
                                types: structs,
                                functions: [],
                                events: [],
                            };
                        }
                        delete this._customTypeHashToName; // Clean up instance state
                        return [2 /*return*/, doc];
                }
            });
        });
    };
    SolDoc.prototype._getCustomTypeFromDataItem = function (inputOrOutput) {
        var _this = this;
        var customType = {
            name: _.capitalize(inputOrOutput.name),
            kindString: 'Interface',
            children: [],
        };
        _.each(inputOrOutput.components, function (component) {
            var childType = _this._getTypeFromDataItem(component);
            var customTypeChild = {
                name: component.name,
                type: childType,
            };
            // (fabio): Not sure why this type casting is necessary. Seems TS doesn't
            // deduce that `customType.children` cannot be undefined anymore after being
            // set to `[]` above.
            customType.children.push(customTypeChild);
        });
        return customType;
    };
    SolDoc.prototype._getNameFromDataItemIfExists = function (dataItem) {
        if (_.isUndefined(dataItem.components)) {
            return undefined;
        }
        var customType = this._getCustomTypeFromDataItem(dataItem);
        var hash = SolDoc._generateCustomTypeHash(customType);
        if (_.isUndefined(this._customTypeHashToName) || _.isUndefined(this._customTypeHashToName[hash])) {
            return undefined;
        }
        return this._customTypeHashToName[hash];
    };
    SolDoc.prototype._getTypeFromDataItem = function (dataItem) {
        var typeDocType = !_.isUndefined(dataItem.components) ? types_1.TypeDocTypes.Reference : types_1.TypeDocTypes.Intrinsic;
        var typeName;
        if (typeDocType === types_1.TypeDocTypes.Reference) {
            var nameIfExists = this._getNameFromDataItemIfExists(dataItem);
            typeName = _.isUndefined(nameIfExists) ? SolDoc._capitalize(dataItem.name) : nameIfExists;
        }
        else {
            typeName = dataItem.type;
        }
        var isArrayType = _.endsWith(dataItem.type, '[]');
        var type;
        if (isArrayType) {
            // tslint:disable-next-line:custom-no-magic-numbers
            typeName = typeDocType === types_1.TypeDocTypes.Intrinsic ? typeName.slice(0, -2) : typeName;
            type = {
                elementType: { name: typeName, typeDocType: typeDocType },
                typeDocType: types_1.TypeDocTypes.Array,
                name: '',
            };
        }
        else {
            type = { name: typeName, typeDocType: typeDocType };
        }
        return type;
    };
    SolDoc.prototype._overwriteStructNames = function (customTypes) {
        var _this = this;
        if (_.isUndefined(this._customTypeHashToName)) {
            return customTypes;
        }
        var localCustomTypes = _.cloneDeep(customTypes);
        _.each(localCustomTypes, function (customType, i) {
            var hash = SolDoc._generateCustomTypeHash(customType);
            if (!_.isUndefined(_this._customTypeHashToName) && !_.isUndefined(_this._customTypeHashToName[hash])) {
                localCustomTypes[i].name = _this._customTypeHashToName[hash];
            }
        });
        return localCustomTypes;
    };
    SolDoc.prototype._extractStructs = function (compiledContract) {
        var e_6, _a;
        var customTypes = [];
        try {
            for (var _b = __values(compiledContract.abi), _c = _b.next(); !_c.done; _c = _b.next()) {
                var abiDefinition = _c.value;
                var types = [];
                switch (abiDefinition.type) {
                    case 'constructor': {
                        types = this._getStructsAsCustomTypes(abiDefinition);
                        break;
                    }
                    case 'function': {
                        types = this._getStructsAsCustomTypes(abiDefinition);
                        break;
                    }
                    case 'event':
                    case 'fallback':
                        // No types exist
                        break;
                    default:
                        throw new Error("unknown and unsupported AbiDefinition type '" + abiDefinition.type + "'");
                }
                customTypes = __spread(customTypes, types);
            }
        }
        catch (e_6_1) { e_6 = { error: e_6_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_6) throw e_6.error; }
        }
        return customTypes;
    };
    SolDoc.prototype._genDocSection = function (compiledContract, contractName) {
        var e_7, _a;
        var docSection = {
            comment: _.isUndefined(compiledContract.devdoc) ? '' : compiledContract.devdoc.title,
            constructors: [],
            methods: [],
            properties: [],
            types: [],
            functions: [],
            events: [],
        };
        try {
            for (var _b = __values(compiledContract.abi), _c = _b.next(); !_c.done; _c = _b.next()) {
                var abiDefinition = _c.value;
                switch (abiDefinition.type) {
                    case 'constructor':
                        docSection.constructors.push(
                        // tslint:disable-next-line:no-unnecessary-type-assertion
                        this._genConstructorDoc(contractName, abiDefinition, compiledContract.devdoc));
                        break;
                    case 'event':
                        // tslint:disable-next-line:no-unnecessary-type-assertion
                        docSection.events.push(SolDoc._genEventDoc(abiDefinition));
                        // note that we're not sending devdoc to this._genEventDoc().
                        // that's because the type of the events array doesn't have any fields for documentation!
                        break;
                    case 'function':
                        // tslint:disable-next-line:no-unnecessary-type-assertion
                        docSection.methods.push(this._genMethodDoc(abiDefinition, compiledContract.devdoc));
                        break;
                    case 'fallback':
                        // tslint:disable-next-line:no-unnecessary-type-assertion
                        docSection.methods.push(SolDoc._genFallbackDoc(abiDefinition, compiledContract.devdoc));
                        break;
                    default:
                        throw new Error("unknown and unsupported AbiDefinition type '" + abiDefinition.type + "'");
                }
            }
        }
        catch (e_7_1) { e_7 = { error: e_7_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_7) throw e_7.error; }
        }
        return docSection;
    };
    SolDoc.prototype._genConstructorDoc = function (contractName, abiDefinition, devdocIfExists) {
        var _a = this._genMethodParamsDoc('', abiDefinition.inputs, devdocIfExists), parameters = _a.parameters, methodSignature = _a.methodSignature;
        var comment = SolDoc._devdocMethodDetailsIfExist(methodSignature, devdocIfExists);
        var constructorDoc = {
            isConstructor: true,
            name: contractName,
            callPath: '',
            parameters: parameters,
            returnType: { name: contractName, typeDocType: types_1.TypeDocTypes.Reference },
            isConstant: false,
            isPayable: abiDefinition.payable,
            comment: comment,
        };
        return constructorDoc;
    };
    SolDoc.prototype._genMethodDoc = function (abiDefinition, devdocIfExists) {
        var name = abiDefinition.name;
        var _a = this._genMethodParamsDoc(name, abiDefinition.inputs, devdocIfExists), parameters = _a.parameters, methodSignature = _a.methodSignature;
        var devDocComment = SolDoc._devdocMethodDetailsIfExist(methodSignature, devdocIfExists);
        var returnType = this._genMethodReturnTypeDoc(abiDefinition.outputs);
        var returnComment = _.isUndefined(devdocIfExists) || _.isUndefined(devdocIfExists.methods[methodSignature])
            ? undefined
            : devdocIfExists.methods[methodSignature].return;
        var hasNoNamedParameters = _.isUndefined(_.find(parameters, function (p) { return !_.isEmpty(p.name); }));
        var isGeneratedGetter = hasNoNamedParameters;
        var comment = _.isEmpty(devDocComment) && isGeneratedGetter
            ? "This is an auto-generated accessor method of the '" + name + "' contract instance variable."
            : devDocComment;
        var methodDoc = {
            isConstructor: false,
            name: name,
            callPath: '',
            parameters: parameters,
            returnType: returnType,
            returnComment: returnComment,
            isConstant: abiDefinition.constant,
            isPayable: abiDefinition.payable,
            comment: comment,
        };
        return methodDoc;
    };
    /**
     * Extract documentation for each method parameter from @param params.
     */
    SolDoc.prototype._genMethodParamsDoc = function (name, abiParams, devdocIfExists) {
        var e_8, _a, e_9, _b;
        var parameters = [];
        try {
            for (var abiParams_1 = __values(abiParams), abiParams_1_1 = abiParams_1.next(); !abiParams_1_1.done; abiParams_1_1 = abiParams_1.next()) {
                var abiParam = abiParams_1_1.value;
                var type = this._getTypeFromDataItem(abiParam);
                var parameter = {
                    name: abiParam.name,
                    comment: '<No comment>',
                    isOptional: false,
                    type: type,
                };
                parameters.push(parameter);
            }
        }
        catch (e_8_1) { e_8 = { error: e_8_1 }; }
        finally {
            try {
                if (abiParams_1_1 && !abiParams_1_1.done && (_a = abiParams_1.return)) _a.call(abiParams_1);
            }
            finally { if (e_8) throw e_8.error; }
        }
        var methodSignature = name + "(" + abiParams
            .map(function (abiParam) {
            if (!_.startsWith(abiParam.type, 'tuple')) {
                return abiParam.type;
            }
            else {
                // Need to expand tuples:
                // E.g: fillOrder(tuple,uint256,bytes) -> fillOrder((address,address,address,address,uint256,uint256,uint256,uint256,uint256,uint256,bytes,bytes),uint256,bytes)
                var isArray = _.endsWith(abiParam.type, '[]');
                var expandedTypes = _.map(abiParam.components, function (c) { return c.type; });
                var type = "(" + expandedTypes.join(',') + ")" + (isArray ? '[]' : '');
                return type;
            }
        })
            .join(',') + ")";
        if (!_.isUndefined(devdocIfExists)) {
            var devdocMethodIfExists = devdocIfExists.methods[methodSignature];
            if (!_.isUndefined(devdocMethodIfExists)) {
                var devdocParamsIfExist = devdocMethodIfExists.params;
                if (!_.isUndefined(devdocParamsIfExist)) {
                    try {
                        for (var parameters_1 = __values(parameters), parameters_1_1 = parameters_1.next(); !parameters_1_1.done; parameters_1_1 = parameters_1.next()) {
                            var parameter = parameters_1_1.value;
                            parameter.comment = devdocParamsIfExist[parameter.name];
                        }
                    }
                    catch (e_9_1) { e_9 = { error: e_9_1 }; }
                    finally {
                        try {
                            if (parameters_1_1 && !parameters_1_1.done && (_b = parameters_1.return)) _b.call(parameters_1);
                        }
                        finally { if (e_9) throw e_9.error; }
                    }
                }
            }
        }
        return { parameters: parameters, methodSignature: methodSignature };
    };
    SolDoc.prototype._genMethodReturnTypeDoc = function (outputs) {
        var e_10, _a;
        var type;
        if (outputs.length > 1) {
            type = {
                name: '',
                typeDocType: types_1.TypeDocTypes.Tuple,
                tupleElements: [],
            };
            try {
                for (var outputs_1 = __values(outputs), outputs_1_1 = outputs_1.next(); !outputs_1_1.done; outputs_1_1 = outputs_1.next()) {
                    var output = outputs_1_1.value;
                    var tupleType = this._getTypeFromDataItem(output);
                    type.tupleElements.push(tupleType);
                }
            }
            catch (e_10_1) { e_10 = { error: e_10_1 }; }
            finally {
                try {
                    if (outputs_1_1 && !outputs_1_1.done && (_a = outputs_1.return)) _a.call(outputs_1);
                }
                finally { if (e_10) throw e_10.error; }
            }
            return type;
        }
        else if (outputs.length === 1) {
            var output = outputs[0];
            type = this._getTypeFromDataItem(output);
        }
        else {
            type = {
                name: 'void',
                typeDocType: types_1.TypeDocTypes.Intrinsic,
            };
        }
        return type;
    };
    SolDoc.prototype._getStructsAsCustomTypes = function (abiDefinition) {
        var _this = this;
        var customTypes = [];
        // We cast to `any` here because we do not know yet if this type of abiDefinition contains
        // an `input` key
        if (!_.isUndefined(abiDefinition.inputs)) {
            var methodOrConstructorAbi = abiDefinition;
            _.each(methodOrConstructorAbi.inputs, function (input) {
                if (!_.isUndefined(input.components)) {
                    var customType = _this._getCustomTypeFromDataItem(input);
                    customTypes.push(customType);
                }
            });
        }
        if (!_.isUndefined(abiDefinition.outputs)) {
            var methodAbi = abiDefinition; // tslint:disable-line:no-unnecessary-type-assertion
            _.each(methodAbi.outputs, function (output) {
                if (!_.isUndefined(output.components)) {
                    var customType = _this._getCustomTypeFromDataItem(output);
                    customTypes.push(customType);
                }
            });
        }
        return customTypes;
    };
    return SolDoc;
}());
exports.SolDoc = SolDoc;
// tslint:disable:max-file-line-count
//# sourceMappingURL=sol_doc.js.map