"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var chai = require("chai");
require("mocha");
var sol_doc_1 = require("../src/sol_doc");
var chai_setup_1 = require("./util/chai_setup");
chai_setup_1.chaiSetup.configure();
var expect = chai.expect;
var solDoc = new sol_doc_1.SolDoc();
describe('#SolidityDocGenerator', function () {
    it('should generate a doc object that matches the devdoc-free TokenTransferProxy fixture', function () { return __awaiter(_this, void 0, void 0, function () {
        var doc;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, solDoc.generateSolDocAsync(__dirname + "/../../test/fixtures/contracts", [
                        'TokenTransferProxyNoDevdoc',
                    ])];
                case 1:
                    doc = _a.sent();
                    expect(doc).to.not.be.undefined();
                    verifyTokenTransferProxyABIIsDocumented(doc, 'TokenTransferProxyNoDevdoc');
                    return [2 /*return*/];
            }
        });
    }); });
    var docPromises = [
        solDoc.generateSolDocAsync(__dirname + "/../../test/fixtures/contracts"),
        solDoc.generateSolDocAsync(__dirname + "/../../test/fixtures/contracts", []),
    ];
    docPromises.forEach(function (docPromise) {
        it('should generate a doc object that matches the TokenTransferProxy fixture with its dependencies', function () { return __awaiter(_this, void 0, void 0, function () {
            var e_1, _a, doc, addAuthorizedAddressMethod, _b, _c, method, tokenTransferProxyAddAuthorizedAddressComment, expectedParamComment;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0: return [4 /*yield*/, docPromise];
                    case 1:
                        doc = _d.sent();
                        expect(doc).to.not.be.undefined();
                        verifyTokenTransferProxyAndDepsABIsAreDocumented(doc, 'TokenTransferProxy');
                        try {
                            for (_b = __values(doc.TokenTransferProxy.methods), _c = _b.next(); !_c.done; _c = _b.next()) {
                                method = _c.value;
                                if (method.name === 'addAuthorizedAddress') {
                                    addAuthorizedAddressMethod = method;
                                }
                            }
                        }
                        catch (e_1_1) { e_1 = { error: e_1_1 }; }
                        finally {
                            try {
                                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                            }
                            finally { if (e_1) throw e_1.error; }
                        }
                        tokenTransferProxyAddAuthorizedAddressComment = 'Authorizes an address.';
                        expect(addAuthorizedAddressMethod.comment).to.equal(tokenTransferProxyAddAuthorizedAddressComment);
                        expectedParamComment = 'Address to authorize.';
                        expect(addAuthorizedAddressMethod.parameters[0].comment).to.equal(expectedParamComment);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    it('should generate a doc object that matches the TokenTransferProxy fixture', function () { return __awaiter(_this, void 0, void 0, function () {
        var doc;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, solDoc.generateSolDocAsync(__dirname + "/../../test/fixtures/contracts", [
                        'TokenTransferProxy',
                    ])];
                case 1:
                    doc = _a.sent();
                    verifyTokenTransferProxyABIIsDocumented(doc, 'TokenTransferProxy');
                    return [2 /*return*/];
            }
        });
    }); });
    describe('when processing all the permutations of devdoc stuff that we use in our contracts', function () {
        var doc;
        before(function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, solDoc.generateSolDocAsync(__dirname + "/../../test/fixtures/contracts", ['NatspecEverything'])];
                    case 1:
                        doc = _a.sent();
                        expect(doc).to.not.be.undefined();
                        expect(doc.NatspecEverything).to.not.be.undefined();
                        return [2 /*return*/];
                }
            });
        }); });
        it('should emit the contract @title as its comment', function () {
            expect(doc.NatspecEverything.comment).to.equal('Contract Title');
        });
        describe('should emit public method documentation for', function () {
            var methodDoc;
            before(function () {
                // tslint:disable-next-line:no-unnecessary-type-assertion
                methodDoc = doc.NatspecEverything.methods.find(function (method) {
                    return method.name === 'publicMethod';
                });
                if (_.isUndefined(methodDoc)) {
                    throw new Error('publicMethod not found');
                }
            });
            it('method name', function () {
                expect(methodDoc.name).to.equal('publicMethod');
            });
            it('method comment', function () {
                expect(methodDoc.comment).to.equal('publicMethod @dev');
            });
            it('parameter name', function () {
                expect(methodDoc.parameters[0].name).to.equal('p');
            });
            it('parameter comment', function () {
                expect(methodDoc.parameters[0].comment).to.equal('publicMethod @param');
            });
            it('return type', function () {
                expect(methodDoc.returnType.name).to.equal('int256');
            });
            it('return comment', function () {
                expect(methodDoc.returnComment).to.equal('publicMethod @return');
            });
        });
        describe('should emit external method documentation for', function () {
            var methodDoc;
            before(function () {
                // tslint:disable-next-line:no-unnecessary-type-assertion
                methodDoc = doc.NatspecEverything.methods.find(function (method) {
                    return method.name === 'externalMethod';
                });
                if (_.isUndefined(methodDoc)) {
                    throw new Error('externalMethod not found');
                }
            });
            it('method name', function () {
                expect(methodDoc.name).to.equal('externalMethod');
            });
            it('method comment', function () {
                expect(methodDoc.comment).to.equal('externalMethod @dev');
            });
            it('parameter name', function () {
                expect(methodDoc.parameters[0].name).to.equal('p');
            });
            it('parameter comment', function () {
                expect(methodDoc.parameters[0].comment).to.equal('externalMethod @param');
            });
            it('return type', function () {
                expect(methodDoc.returnType.name).to.equal('int256');
            });
            it('return comment', function () {
                expect(methodDoc.returnComment).to.equal('externalMethod @return');
            });
        });
        it('should not truncate a multi-line devdoc comment', function () {
            // tslint:disable-next-line:no-unnecessary-type-assertion
            var methodDoc = doc.NatspecEverything.methods.find(function (method) {
                return method.name === 'methodWithLongDevdoc';
            });
            if (_.isUndefined(methodDoc)) {
                throw new Error('methodWithLongDevdoc not found');
            }
            expect(methodDoc.comment).to.equal('Here is a really long developer documentation comment, which spans multiple lines, for the purposes of making sure that broken lines are consolidated into one devdoc comment.');
        });
        describe('should emit event documentation for', function () {
            var eventDoc;
            before(function () {
                eventDoc = doc.NatspecEverything.events[0];
            });
            it('event name', function () {
                expect(eventDoc.name).to.equal('AnEvent');
            });
            it('parameter name', function () {
                expect(eventDoc.eventArgs[0].name).to.equal('p');
            });
        });
        it('should not let solhint directives obscure natspec content', function () {
            // tslint:disable-next-line:no-unnecessary-type-assertion
            var methodDoc = doc.NatspecEverything.methods.find(function (method) {
                return method.name === 'methodWithSolhintDirective';
            });
            if (_.isUndefined(methodDoc)) {
                throw new Error('methodWithSolhintDirective not found');
            }
            expect(methodDoc.comment).to.equal('methodWithSolhintDirective @dev');
        });
    });
    it('should document a method that returns multiple values', function () { return __awaiter(_this, void 0, void 0, function () {
        var e_2, _a, doc, methodWithMultipleReturnValues, _b, _c, method, returnType;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0: return [4 /*yield*/, solDoc.generateSolDocAsync(__dirname + "/../../test/fixtures/contracts", [
                        'MultipleReturnValues',
                    ])];
                case 1:
                    doc = _d.sent();
                    expect(doc.MultipleReturnValues).to.not.be.undefined();
                    expect(doc.MultipleReturnValues.methods).to.not.be.undefined();
                    try {
                        for (_b = __values(doc.MultipleReturnValues.methods), _c = _b.next(); !_c.done; _c = _b.next()) {
                            method = _c.value;
                            if (method.name === 'methodWithMultipleReturnValues') {
                                methodWithMultipleReturnValues = method;
                            }
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                    if (_.isUndefined(methodWithMultipleReturnValues)) {
                        throw new Error('method should not be undefined');
                    }
                    returnType = methodWithMultipleReturnValues.returnType;
                    expect(returnType.typeDocType).to.equal('tuple');
                    if (_.isUndefined(returnType.tupleElements)) {
                        throw new Error('returnType.tupleElements should not be undefined');
                    }
                    expect(returnType.tupleElements.length).to.equal(2);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should document a method that has a struct param and return value', function () { return __awaiter(_this, void 0, void 0, function () {
        var e_3, _a, doc, methodWithStructParamAndReturn, _b, _c, method;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0: return [4 /*yield*/, solDoc.generateSolDocAsync(__dirname + "/../../test/fixtures/contracts", [
                        'StructParamAndReturn',
                    ])];
                case 1:
                    doc = _d.sent();
                    expect(doc.StructParamAndReturn).to.not.be.undefined();
                    expect(doc.StructParamAndReturn.methods).to.not.be.undefined();
                    try {
                        for (_b = __values(doc.StructParamAndReturn.methods), _c = _b.next(); !_c.done; _c = _b.next()) {
                            method = _c.value;
                            if (method.name === 'methodWithStructParamAndReturn') {
                                methodWithStructParamAndReturn = method;
                            }
                        }
                    }
                    catch (e_3_1) { e_3 = { error: e_3_1 }; }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                        }
                        finally { if (e_3) throw e_3.error; }
                    }
                    if (_.isUndefined(methodWithStructParamAndReturn)) {
                        throw new Error('method should not be undefined');
                    }
                    /**
                     * Solc maps devDoc comments to methods using a method signature. If we incorrectly
                     * generate the methodSignatures, the devDoc comments won't be correctly associated
                     * with their methods and they won't show up in the output. By checking that the comments
                     * are included for a method with structs as params/returns, we are sure that the methodSignature
                     * generation is correct for this case.
                     */
                    expect(methodWithStructParamAndReturn.comment).to.be.equal('DEV_COMMENT');
                    expect(methodWithStructParamAndReturn.returnComment).to.be.equal('RETURN_COMMENT');
                    expect(methodWithStructParamAndReturn.parameters[0].comment).to.be.equal('STUFF_COMMENT');
                    return [2 /*return*/];
            }
        });
    }); });
    it('should document the structs included in a contract', function () { return __awaiter(_this, void 0, void 0, function () {
        var doc;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, solDoc.generateSolDocAsync(__dirname + "/../../test/fixtures/contracts", [
                        'StructParamAndReturn',
                    ])];
                case 1:
                    doc = _a.sent();
                    expect(doc.structs).to.not.be.undefined();
                    expect(doc.structs.types.length).to.be.equal(1);
                    return [2 /*return*/];
            }
        });
    }); });
});
function verifyTokenTransferProxyABIIsDocumented(doc, contractName) {
    expect(doc[contractName]).to.not.be.undefined();
    expect(doc[contractName].constructors).to.not.be.undefined();
    var tokenTransferProxyConstructorCount = 0;
    var tokenTransferProxyMethodCount = 8;
    var tokenTransferProxyEventCount = 3;
    expect(doc[contractName].constructors.length).to.equal(tokenTransferProxyConstructorCount);
    expect(doc[contractName].methods.length).to.equal(tokenTransferProxyMethodCount);
    var events = doc[contractName].events;
    if (_.isUndefined(events)) {
        throw new Error('events should never be undefined');
    }
    expect(events.length).to.equal(tokenTransferProxyEventCount);
}
function verifyTokenTransferProxyAndDepsABIsAreDocumented(doc, contractName) {
    var e_4, _a;
    verifyTokenTransferProxyABIIsDocumented(doc, contractName);
    expect(doc.ERC20).to.not.be.undefined();
    expect(doc.ERC20.constructors).to.not.be.undefined();
    expect(doc.ERC20.methods).to.not.be.undefined();
    var erc20ConstructorCount = 0;
    var erc20MethodCount = 6;
    var erc20EventCount = 2;
    expect(doc.ERC20.constructors.length).to.equal(erc20ConstructorCount);
    expect(doc.ERC20.methods.length).to.equal(erc20MethodCount);
    if (_.isUndefined(doc.ERC20.events)) {
        throw new Error('events should never be undefined');
    }
    expect(doc.ERC20.events.length).to.equal(erc20EventCount);
    expect(doc.ERC20Basic).to.not.be.undefined();
    expect(doc.ERC20Basic.constructors).to.not.be.undefined();
    expect(doc.ERC20Basic.methods).to.not.be.undefined();
    var erc20BasicConstructorCount = 0;
    var erc20BasicMethodCount = 3;
    var erc20BasicEventCount = 1;
    expect(doc.ERC20Basic.constructors.length).to.equal(erc20BasicConstructorCount);
    expect(doc.ERC20Basic.methods.length).to.equal(erc20BasicMethodCount);
    if (_.isUndefined(doc.ERC20Basic.events)) {
        throw new Error('events should never be undefined');
    }
    expect(doc.ERC20Basic.events.length).to.equal(erc20BasicEventCount);
    var addAuthorizedAddressMethod;
    try {
        for (var _b = __values(doc[contractName].methods), _c = _b.next(); !_c.done; _c = _b.next()) {
            var method = _c.value;
            if (method.name === 'addAuthorizedAddress') {
                addAuthorizedAddressMethod = method;
            }
        }
    }
    catch (e_4_1) { e_4 = { error: e_4_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_4) throw e_4.error; }
    }
    expect(addAuthorizedAddressMethod, "method addAuthorizedAddress not found in " + JSON.stringify(doc[contractName].methods)).to.not.be.undefined();
}
//# sourceMappingURL=solidity_doc_generator_test.js.map